OGRE-Next: Ogre::v1::HardwareBufferManagerBase Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::HardwareBufferManagerBase Class Referenceabstract
Core » RenderSystem

Base definition of a hardware buffer manager. More...

`#include <OgreHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::HardwareBufferManagerBase:
[legend]

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE , BLT_AUTOMATIC_RELEASE }

## Public Member Functions
| HardwareBufferManagerBase ()
virtual | ~HardwareBufferManagerBase ()
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _freeUnusedBufferCopies ()
| Free all unused vertex buffer copies.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware index buffer.
virtual HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware vertex buffer.
virtual VertexBufferBinding * | createVertexBufferBinding ()
| Creates a new VertexBufferBinding.
virtual VertexDeclaration * | createVertexDeclaration ()
| Creates a new vertex declaration.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.

## Detailed Description

Base definition of a hardware buffer manager.

Remarks
  This class is deliberately not a Singleton, so that multiple types can exist at once. The Singleton is wrapped via the Decorator pattern in HardwareBufferManager, below. Each concrete implementation should provide a subclass of HardwareBufferManagerBase, which does the actual work, and also a very simple subclass of HardwareBufferManager which simply constructs the instance of the HardwareBufferManagerBase subclass and passes it to the HardwareBufferManager superclass as a delegate. This subclass must also delete the implementation instance it creates.

## Member Enumeration Documentation

## ◆ BufferLicenseType

enum Ogre::v1::HardwareBufferManagerBase::BufferLicenseType

Enumerator
BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

## Constructor & Destructor Documentation

## ◆ HardwareBufferManagerBase()

Ogre::v1::HardwareBufferManagerBase::HardwareBufferManagerBase | ( |  | ) |

Referenced by Ogre::v1::HardwareBufferManager::HardwareBufferManager(), and Ogre::v1::HardwareBufferManager::HardwareIndexBufferSharedPtr.

## ◆ ~HardwareBufferManagerBase()

virtual Ogre::v1::HardwareBufferManagerBase::~HardwareBufferManagerBase | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _forceReleaseBufferCopies() [1/2]

virtual void Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) |
| virtual

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented in Ogre::v1::HardwareBufferManager.

References HardwareVertexBufferSharedPtr.

## ◆ _forceReleaseBufferCopies() [2/2]

virtual void Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) |
| virtual

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ _freeUnusedBufferCopies()

virtual void Ogre::v1::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( |  | ) |
| virtual

Free all unused vertex buffer copies.

Remarks
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ _notifyIndexBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) |

Notification that a hardware index buffer has been destroyed.

## ◆ _notifyVertexBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) |

Notification that a hardware vertex buffer has been destroyed.

## ◆ _releaseBufferCopies()

virtual void Ogre::v1::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = false | ) |
| virtual

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters

  forceFreeUnused | If `true`, free all unused temporary buffers. If `false`, auto detect and free all unused temporary buffers based on temporary buffers utilization.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ allocateVertexBufferCopy()

virtual HardwareVertexBufferSharedPtr Ogre::v1::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = false )
| virtual

Allocates a copy of a given vertex buffer.

Remarks
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters

  sourceBuffer | The source buffer to use as a copy.
  licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If `true`, the current data is copied as well as the structure of the buffer/

Reimplemented in Ogre::v1::HardwareBufferManager.

References HardwareVertexBufferSharedPtr.

## ◆ createIndexBuffer()

virtual HardwareIndexBufferSharedPtr Ogre::v1::HardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| pure virtual

Create a hardware index buffer.

Remarks
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  numIndexes | The number of indexes in the buffer
  usage | One or more members of the HardwareBuffer::Usage enumeration.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the index buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implemented in Ogre::v1::D3D11HardwareBufferManagerBase, Ogre::v1::DefaultHardwareBufferManagerBase, Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase, Ogre::v1::GL3PlusHardwareBufferManagerBase, Ogre::v1::GLES2DefaultHardwareBufferManagerBase, Ogre::v1::GLES2HardwareBufferManagerBase, Ogre::v1::HardwareBufferManager, Ogre::v1::MetalHardwareBufferManagerBase, and Ogre::v1::VulkanHardwareBufferManagerBase.

References HardwareIndexBufferSharedPtr.

Referenced by Ogre::VerticesRemapInfo::performIndexDataRemap().

## ◆ createVertexBuffer()

virtual HardwareVertexBufferSharedPtr Ogre::v1::HardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false )
| pure virtual

Create a hardware vertex buffer.

Remarks
  This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data.
  Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying themm this will be done automatically.

Parameters

  vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  numVerts | The number of vertices in this buffer.
  usage | One or more members of the HardwareBuffer::Usage enumeration; you are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY and useShadowBuffer=true.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the vertex buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implemented in Ogre::v1::D3D11HardwareBufferManagerBase, Ogre::v1::DefaultHardwareBufferManagerBase, Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase, Ogre::v1::GL3PlusHardwareBufferManagerBase, Ogre::v1::GLES2DefaultHardwareBufferManagerBase, Ogre::v1::GLES2HardwareBufferManagerBase, Ogre::v1::HardwareBufferManager, Ogre::v1::MetalHardwareBufferManagerBase, and Ogre::v1::VulkanHardwareBufferManagerBase.

References HardwareVertexBufferSharedPtr.

Referenced by Ogre::VerticesRemapInfo::getRemappedVertexBuffer().

## ◆ createVertexBufferBinding()

virtual VertexBufferBinding * Ogre::v1::HardwareBufferManagerBase::createVertexBufferBinding | ( |  | ) |
| virtual

Creates a new VertexBufferBinding.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ createVertexDeclaration()

virtual VertexDeclaration * Ogre::v1::HardwareBufferManagerBase::createVertexDeclaration | ( |  | ) |
| virtual

Creates a new vertex declaration.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ destroyVertexBufferBinding()

virtual void Ogre::v1::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) |
| virtual

Destroys a VertexBufferBinding.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ destroyVertexDeclaration()

virtual void Ogre::v1::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) |
| virtual

Destroys a vertex declaration.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ registerVertexBufferSourceAndCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy )
| virtual

Registers a vertex buffer as a copy of another.

Remarks
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

Reimplemented in Ogre::v1::HardwareBufferManager.

References HardwareVertexBufferSharedPtr.

## ◆ releaseVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| virtual

Manually release a vertex buffer copy for others to subsequently use.

Remarks
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

Reimplemented in Ogre::v1::HardwareBufferManager.

References HardwareVertexBufferSharedPtr.

## ◆ touchVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| virtual

Tell engine that the vertex buffer copy intent to reuse.

Remarks
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters

  bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

Reimplemented in Ogre::v1::HardwareBufferManager.

References HardwareVertexBufferSharedPtr.

The documentation for this class was generated from the following file:

- OgreHardwareBufferManager.h